//+------------------------------------------------------------------+
//|                                             pipchannel indicator |
//|                                                            Mikko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Mikko"
#property link      "http://www.currencylabs.com"

//#property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Silver
#property indicator_color2 Silver

double high[];
double low[];

extern int pipsMove = 50;
extern int channelWidth = 100;

int init() {

   IndicatorBuffers(2);
   SetIndexBuffer(0, high);   
   SetIndexStyle(0, DRAW_LINE, EMPTY, 1); 
   
   SetIndexBuffer(1, low);     
   SetIndexStyle(1, DRAW_LINE, EMPTY, 1);
   
   IndicatorShortName("Mikko pipschannel");
        
   return(0);
}
  
int deinit() {
   return(0);
}
     
int start() {
       
   int counted_bars=IndicatorCounted();
  
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
       
   int limit = Bars - counted_bars;      
   
   for(int i = limit-1; i >= 0; i--) {      
         
      high[i] = high[i+1];
      low[i] = low[i+1];
      
      while(High[i+1] > high[i]+pipsMove*Point) {
         high[i] = high[i]+pipsMove*Point;
         low[i] = high[i]-channelWidth*Point;
      } 
      
      while(Low[i+1] < low[i]-pipsMove*Point) {
         low[i] = low[i]-pipsMove*Point;
         high[i] = low[i]+channelWidth*Point;
      }
   } 
   return(0);
}

